// Teil des Projekts "LinADT" -- Keller und Schlange -- Umgebung fr Aufgaben 20 und 21
// R. Krell (www.r-krell.de) zu Seite 14 von "keller-und-schlange_(r-krell).pdf, 22.12.2006
// Diese Datei nicht verndern, nur ADT_TauschKellerX und ADT_ErwSchlangeX ergnzen!

public class ADT_Schlange1 extends ADT_StatSpeicherMitEndzugriff
// Schlange als Erbe der abstrakten Oberklasse mit zustzl. Definitionen
{
  protected int schwanz;

  public ADT_Schlange1()        // Konstruktor fr neue, leere Schlange
  {
    super();
    schwanz = 0;                // weil noch nichts da ist, steht der schwanz noch
  }                             // rechts' vom knftigen 1. El. bei -1 = MAX-1
  
  public void rein (Object element) // bergebenes Element kommt in Speicher
  {
    schwanz = (schwanz+MAX-1) % MAX;  // Neue Elemente stehen links von vorhandenen
    reihung[schwanz] = element;   // das letzte eingeschlangte (=hinterste) Element
  }                            // steht am Index schwanz
  
  public boolean istLeer()     // sagt, ob der Speicher leer ist
  {
    return ((kopf+1)%MAX == schwanz);  // schwanz berholt kopf gerade
  }
}

