// Teil des Projekts "LinADT" -- Keller und Schlange als Geschwister
// R. Krell (www.r-krell.de) zu Anhang 2 von "keller-und-schlange_(r-krell).pdf, 22.12.2006

public abstract class ADT_StatSpeicherMitEndzugriff implements ADT_Speicher
// Nachtrag: Gemeinsame Oberklasse fr Keller und Schlange
{
  protected final int MAX = 100; // stat. Gre;  MAX-1 = Maximale Zahl der Elemente
  protected Object[] reihung;
  protected int kopf;
  
  public ADT_StatSpeicherMitEndzugriff()   // Konstruktor fr neuen, leeren Speicher
  {
    reihung = new Object[MAX]; // Anlegen der statischen Datenstruktur
    kopf = MAX-1;              // wegen raus;
  }
  
  public abstract void rein (Object element); // bergebenes Element kommt in Speicher
   // abtrakte Klasse: Wird von Keller und Schlange verschieden implementiert
   
  public abstract boolean istLeer();          // sagt, ob der Speicher leer ist
   // abtrakte Klasse: Wird von Keller und Schlange verschieden implementiert
   
  public Object zeige()        // zeigt oberstes Element ohne ndern des Speichers
  {
    return (reihung[kopf]);
  }
  
  public Object raus()         // zeigt oberstes El. und lscht es aus dem Speicher
  {
    Object hilf = reihung[kopf];
    kopf = (kopf+MAX-1) % MAX;  // reduziert kopf um 1. Nur nach 0 kommt wieder MAX-1
    return (hilf);
  }
}

