// Teil des Projekts typisierte lineare abstrakte Datentypen -- nur ab Java (1.)5
// R. Krell (www.r-krell.de) -- 21.12.2006 -- Java JDK 1.5+ ntig

public class TADT_Knoten <Elementtyp>      // = rote Plastikwanne
{
  private Elementtyp inhalt;               // Fach fr den Inhalt
  private TADT_Knoten<Elementtyp> zeiger;  // "Kartentasche" fr den Verweis auf anderen Knoten

  public TADT_Knoten (Elementtyp neuesElement, TADT_Knoten<Elementtyp> nachbar) // Konstruktor
  {
    inhalt = neuesElement;
    zeiger = nachbar;
  }

  public Elementtyp holeInhalt()
  {
    return (inhalt);
  }

  public TADT_Knoten<Elementtyp> holeNachbarKnoten()
  {
    return (zeiger);
  }

  public void ndereNachbarn (TADT_Knoten<Elementtyp> neuerNachbar) // fr Schlange
  {
    zeiger = neuerNachbar;
  }
}

