// Teil des Projekts "LinADT" -- Keller und Schlange als Geschwister
// R. Krell (www.r-krell.de) zu Anhang 2 von "keller-und-schlange_(r-krell).pdf, 22.12.2006

public class ADT_Keller1 extends ADT_StatSpeicherMitEndzugriff
// Keller als Erbe der abstrakten Oberklasse mit zustzl. Definitionen
{

  public ADT_Keller1()         // Konstruktor fr neuen, leeren Keller
  {
    super();                   // kopf = MAX-1 wegen raus; reihung[MAX-1] nicht benutzbar
  }
  
  public void rein (Object element) // bergebenes Element kommt in Speicher
  {
    kopf=(kopf+1)%MAX;         // ntig wegen Schritt von 0 auf 1 Element! Sonst reicht kopf++
    reihung[kopf] = element;   // das letzte eingekellerte (=oberste) Element
  }                            // steht am Index kopf
  
  public boolean istLeer()     // sagt, ob der Speicher leer ist
  {
    return (kopf == MAX-1);    // vgl. Konstruktor und raus (aus Oberklasse)
  }
  
}

