// Teil des Projekts "LinADT" -- Keller und Schlange als Geschwister
// R. Krell (www.r-krell.de) zu Anhang 2 von "keller-und-schlange_(r-krell).pdf, 22.12.2006

public class ADT_Schlange extends ADT_DynSpeicherMitEndzugriff
// Nachtrag: Implementation, die von abstrakter Oberklasse erbt und nur rein neu schreibt
// und zustzlich den schwanz einfhrt
{
  protected ADT_Knoten schwanz; // kopf existiert schon im und durch abstrakte Oberklasse

  public ADT_Schlange ()
  {
    super();        // Konstruktor der abstr. Oberkl. ADT_DynSpeicherMitEndzugriff aufrufen
    schwanz = null; // zustzlich
  }

  public void rein (Object neuesElement)  // neu (anstelle abstrakter Klasse)
  {
    ADT_Knoten neu = new ADT_Knoten (neuesElement, null);
    if (istLeer())
    {
      kopf = neu;   //1. Element: auch kopf muss auf den neuen Knoten zeigen
    }               //hierfr darf kopf hchstens 'protected', nicht 'private' sein.
    else
    {
      schwanz.ndereNachbarn(neu);  //sonst: Vorgnger muss auf den neuen Knoten zeigen
    }
    schwanz = neu;  //immer zeigt auch der Schwanz auf den letzten Knoten
  }
}

